﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Calendar;
using HeuristicLab.Hive.Contracts;
using HeuristicLab.Hive.Slave.Common;
using HeuristicLab.Hive.Slave.Communication;
using HeuristicLab.Hive.Slave.Core.ConfigurationManager;
using HeuristicLab.Hive.Slave.Core.SlaveConsoleService.Interfaces;
using HeuristicLab.Core;


namespace HeuristicLab.Hive.Slave.Core.SlaveConsoleService {
  public class SlaveConsoleCommunicator: ISlaveConsoleCommunicator {
    #region IClientConsoleCommunicator Members

    public StatusCommons GetStatusInfos() {      
        return ConfigManager.Instance.GetStatusForClientConsole();
    }

    public void SetConnection(ConnectionContainer container) {
      ConfigManager.Instance.SetServerIP(container);
    }

    public ConnectionContainer GetCurrentConnection() {
      return new ConnectionContainer();
    }

    public void ShutdownClient() {
      MessageQueue.GetInstance().AddMessage(MessageContainer.MessageType.Shutdown);
    }    

    public void SetUptimeCalendar(List<Appointment> appointments) {
      UptimeManager.Instance.SetAppointments(true, false, appointments);
    }

    public List<Appointment> GetUptimeCalendar() {
      return UptimeManager.Instance.AppContainer.Appointments;
    }

    public List<string> GetLogMessages() {
      return Logger.Log.Messages.ToList();
    }

    #endregion
  }
}
